sequence.sequenceinterface

## Interface ShallowSequence

- All Superinterfaces:
    BaseSequence, CommonBase
  All Known Implementing Classes:
    RealShallowSequence

      public interface ShallowSequence
      extends BaseSequence

  Specifikace mělké posloupnosti.

  Popis: interface pomocné posloupnosti nad členy jiné posloupnosti.

  Užití: k řazení posloupností; implementujte třídou.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `MemberReference` | `getFirstRef()` Vrátí odkaz na první člen posloupnosti.
    `MemberReference` | `getLastRef()` Vrátí odkaz na poslední člen posloupnosti.
    `void` | `insertLast()` Zatřídí poslední prvek před běžný.
    `boolean` | `isFirst()` Zjistí, zda běžný prvek je první.
    `boolean` | `isLast()` Zjistí, zda běžný prvek je poslední.
    `boolean` | `isLatched()` Zjistí, zda byl zachycen nějaký běžný prvek.
    `Element` | `latch()` Zachytí odkaz na běžný prvek v posloupnosti a vrátí jej.
    `ShallowSequence` | `makeLowerHalfSequence()` Vyrobí mělkou kopii posloupnosti obsahující spodní polovinu.
    `ShallowSequence` | `makeShrinkSequence()` Vyrobí mělkou kopii celé posloupnosti.
    `ShallowSequence` | `makeStretchDownSequence()` Vyrobí mělkou kopii posloupnosti obsahující poslední člen.
    `ShallowSequence` | `makeStretchUpSequence()` Vyrobí mělkou kopii posloupnosti obsahující první člen.
    `ShallowSequence` | `makeUpperHalfSequence()` Vyrobí mělkou kopii posloupnosti obsahující horní polovinu.
    `void` | `moveDownTo(int index)` Učiní běžným prvkem index-tý prvek před posledním prvekm.
    `void` | `moveFirst()` Učiní hlavu běžným prvkem.
    `void` | `moveLast()` Učiní ocas běžným prvkem.
    `void` | `moveNext()` Učiní následující prvek běžným prvkem.
    `void` | `movePrev()` Učiní předcházející prvek běžným prvkem.
    `void` | `moveUpTo(int index)` Učiní běžným prvkem index-tý prvek za prvním prvekm.
    `void` | `restore()` Obnoví posledně zachycený běžný prvek.
    `void` | `shrinkDown()` Smrskne posloupnost o jednoho člena před posledního.
    `void` | `shrinkUp()` Smrskne posloupnost o jednoho člena za prvního.
    `void` | `stretchDown()` Roztáhne posloupnost o jednoho člena před prvního.
    `void` | `stretchUp()` Roztáhne posloupnost o jednoho člena za posledního.
    `void` | `swap(CommonBase aSeq)` Zamění běžné prvky dvou posloupností.

    - ### Methods inherited from interface sequence.sequenceinterface.BaseSequence

      `getCount, isEmpty, isFull`

    - ### Methods inherited from interface list.listinterface.CommonBase

      `getElement, getMoveCounter, resetMoveCounter, setElement`

- - ### Method Detail

    - #### moveFirst

          void moveFirst()

      Učiní hlavu běžným prvkem.

    - #### moveLast

          void moveLast()

      Učiní ocas běžným prvkem.

    - #### moveNext

          void moveNext()

      Učiní následující prvek běžným prvkem.

    - #### movePrev

          void movePrev()

      Učiní předcházející prvek běžným prvkem.

    - #### moveUpTo

          void moveUpTo(int index)

      Učiní běžným prvkem index-tý prvek za prvním prvekm.
      Parameters:
        `index` - pořadové číslo prvku

    - #### moveDownTo

          void moveDownTo(int index)

      Učiní běžným prvkem index-tý prvek před posledním prvekm.
      Parameters:
        `index` - pořadové číslo prvku

    - #### isFirst

          boolean isFirst()

      Zjistí, zda běžný prvek je první.
      Returns:
        true když je první, jinak false

    - #### isLast

          boolean isLast()

      Zjistí, zda běžný prvek je poslední.
      Returns:
        true když je poslední, jinak false

    - #### isLatched

          boolean isLatched()

      Zjistí, zda byl zachycen nějaký běžný prvek.
      Returns:
        true když byl zachycen, jinak false

    - #### insertLast

          void insertLast()

      Zatřídí poslední prvek před běžný.

    - #### swap

          void swap(CommonBase aSeq)

      Zamění běžné prvky dvou posloupností.
      Parameters:
        `aSeq` - druhá posloupnost, jejíž prvek se má také zaměnit

    - #### stretchUp

          void stretchUp()

      Roztáhne posloupnost o jednoho člena za posledního.

      Vyžaduje: last nesmí dosáhnout horní hranice hlavní posloupnosti.

    - #### stretchDown

          void stretchDown()

      Roztáhne posloupnost o jednoho člena před prvního.

      Vyžaduje: first nesmí dosáhnout spodní hranice hlavní posloupnosti.

    - #### shrinkUp

          void shrinkUp()

      Smrskne posloupnost o jednoho člena za prvního.

    - #### shrinkDown

          void shrinkDown()

      Smrskne posloupnost o jednoho člena před posledního.

    - #### getFirstRef

          MemberReference getFirstRef()

      Vrátí odkaz na první člen posloupnosti. Dá se porovnat s jiným odkazem.
      Returns:
        odkaz na první člen posloupnosti

    - #### getLastRef

          MemberReference getLastRef()

      Vrátí odkaz na poslední člen posloupnosti. Dá se porovnat s jiným odkazem.
      Returns:
        odkaz na poslední člen posloupnosti

    - #### latch

          Element latch()

      Zachytí odkaz na běžný prvek v posloupnosti a vrátí jej.
      Returns:
        odkaz na běžný prvek v posloupnosti

    - #### restore

          void restore()

      Obnoví posledně zachycený běžný prvek. Učiní z něj prvek běžný.

    - #### makeShrinkSequence

          ShallowSequence makeShrinkSequence()

      Vyrobí mělkou kopii celé posloupnosti.
      Returns:
        mělká kopie celé posloupnosti

    - #### makeStretchUpSequence

          ShallowSequence makeStretchUpSequence()

      Vyrobí mělkou kopii posloupnosti obsahující první člen.
      Returns:
        mělká kopie posloupnosti obsahující první člen

    - #### makeStretchDownSequence

          ShallowSequence makeStretchDownSequence()

      Vyrobí mělkou kopii posloupnosti obsahující poslední člen.
      Returns:
        mělká kopie posloupnosti obsahující poslední člen

    - #### makeLowerHalfSequence

          ShallowSequence makeLowerHalfSequence()

      Vyrobí mělkou kopii posloupnosti obsahující spodní polovinu.
      Returns:
        mělká kopie posloupnosti obsahující spodní polovinu

    - #### makeUpperHalfSequence

          ShallowSequence makeUpperHalfSequence()

      Vyrobí mělkou kopii posloupnosti obsahující horní polovinu.
      Returns:
        mělká kopie posloupnosti obsahující horní polovinu